=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2007-01-24 19:17:04 +0000
+++ loggerhead/controllers/download_ui.py	2007-01-24 19:26:27 +0000
@@ -52,14 +52,10 @@
         
         revid = h.fix_revid(args[0])
         file_id = args[1]
-        filename, content = h.get_file(file_id, revid)
+        path, filename, content = h.get_file(file_id, revid)
         mime_type, encoding = mimetypes.guess_type(filename)
         if mime_type is None:
             mime_type = 'application/octet-stream'
-        
-        path = inv.id2path(file_id)
-        if not path.startswith('/'):
-            path = '/' + path
 
         self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
         response.headers['Content-Type'] = mime_type

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2007-01-21 00:05:52 +0000
+++ loggerhead/history.py	2007-01-24 19:26:27 +0000
@@ -697,10 +697,14 @@
     
     @with_branch_lock
     def get_file(self, file_id, revid):
-        "returns (filename, data)"
-        inv_entry = self.get_inventory(revid)[file_id]
+        "returns (path, filename, data)"
+        inv = self.get_inventory(revid)
+        inv_entry = inv[file_id]
         rev_tree = self._branch.repository.revision_tree(inv_entry.revision)
-        return inv_entry.name, rev_tree.get_file_text(file_id)
+        path = inv.id2path(file_id)
+        if not path.startswith('/'):
+            path = '/' + path
+        return path, inv_entry.name, rev_tree.get_file_text(file_id)
     
     @with_branch_lock
     def parse_delta(self, delta, get_diffs=True, old_tree=None, new_tree=None):

